﻿-- Author      : Nogarder
-- Create Date : 2012/9/7 15:38:35
--register initialize function
--NPA.DataCollector.RegisterModule( datatype, initfunc, uninitfunc )
NPA.DataCollector.RegisterModule("Type",
	function()
		--main --using local for speed
		local floor=floor
		local abs=abs
		local tonumber=tonumber
		local NPA_EventHandler_FireEvent=NPA.EventHandler.FireEvent
		--class by collect unit
		NPA.EventHandler.RegisterEvent(2,"DataCollector_CollectUnit","DataCollector_Type",function(unit,unitdata)
			-- only fire if class is different
			--data.Type= 1=player, 2=totem, 3=creature, 4=vendor, nil=unknow
			local faction,atype,class
			if(UnitIsPlayer(unit))then
				atype=1
			else
				atype=nil
			end
			--local classname,classmark=UnitClass(unit)
			_,class=UnitClass(unit)
			--faction, 1=friendly,2=neutral,3=hostile
			if(UnitIsFriend(unit,"player"))then
				faction=1
			elseif(UnitIsEnemy(unit,"player"))then
				faction=3
			else
				faction=2
			end
			--
			if(unitdata.Class~=class or unitdata.Type~=atype or unitdata.Faction~=faction)then
				unitdata.Type=atype
				unitdata.Class=class
				unitdata.Faction=faction
				--placeholder, don't use it now
				--fire class change event
				NPA_EventHandler_FireEvent(7,"Type_Updated",unitdata)
			end
		end)
		--class by frame default
		--check type
		local NPA_Type_CheckTypeByFramedata=function(framedata)
			--place holder
			return nil,5
			--placeholder
			----first match name with totem table
			--local spellid=1--placeholder NPA_Type_NameToTotemList[framedata.Name]
			--if(spellid)then
			--	--use max health and level to check out other unit like pet
			--	local health=framedata.Default.HealthBar:GetValue()
			--	local healthmax
			--	local level=tonumber(framedata.Default.LevelText:GetText()) or 1
			--	_,healthmax=framedata.Default.HealthBar:GetMinMaxValues() or 1
			--	--totem health is much lower when under 80
			--	if(level<81)then
			--		if(health<level*25)then
			--			return spellid,2
			--		end
			--	else
			--		--totem health much higher above 80
			--		if(health<level*250)then
			--			return spellid,2
			--		end
			--	end
			--	--not totem, supposely is creature
			--	return nil,3
			--end
		end
		--
		local NPA_Type_ColorToClass={}
		--generate color table from blizzard default color table
		for class,color in pairs(RAID_CLASS_COLORS) do
			NPA_Type_ColorToClass[class]={
				R=color.r*100,
				G=color.g*100,
				B=color.b*100
			}
		end
		--check nameplate type with healthbar color
		-- type, classname, istotem
		--local faction,class,type=NPA_Type_GetInfoByFrameData(framedata)
		--faction, 1=friendly,2=neutral,3=hostile
		--class, the class name or totem name , nil=unknow
		--type, 1=player, 2=totem, 3=creature, 4=vendor, 5=unknow

		local NPA_Type_GetInfoByFrameColor=function(r,g,b,framedata)
			--check with color
			---green, blue, yellow are non-hostile
			if(r==0 and g>0.9 and b==0)then -- green is friendly npc
				return 1,NPA_Type_CheckTypeByFramedata(framedata) --check if totem
			elseif(r==0 and g==0 and b>0.9)then --- blue is friendly player 
				return 1,nil,1-- can't get their class without unitdata, handle it after aquired GUID
			elseif(r>0.9 and g>0.9 and b==0)then --- yellow is netural npc or player -- handle it after aquired GUID
				return 2,NPA_Type_CheckTypeByFramedata(framedata) --check if totem
			elseif(r>0.9 and g==0 and b==0)then -- red is hostile npc
				return 3,NPA_Type_CheckTypeByFramedata(framedata) --check if totem
			--r>0.5 and g>0.5 and b>0.5 -- grey is tapped hostile/neutral
			else
				-- hostile players, try to get class with color,+1 to prevent divide zero
				local r=floor(r*100)+1
				local g=floor(g*100)+1
				local b=floor(b*100)+1
				for class,color in pairs(NPA_Type_ColorToClass)do
					-- it's always a little bit off, so allow 10% miss
					if(abs(r-color.R)<10 and abs(g-color.G)<10 and abs(b-color.B)<10)then
						return 3,class,1
					end
				end
				--unknow unit
				return 3,nil,5
			end
		end
		--update basic data
		NPA.EventHandler.RegisterEvent(1,"NamePlate_DefaultMain_OnUpdate","DataCollector_Type",function(framedata)
			local unitdata=framedata.DefaultUnitData
			local r,g,b=framedata.Default.HealthBar:GetStatusBarColor()
			if(r~=unitdata.R or g~=unitdata.G or b~=unitdata.B)then
				unitdata.R=r
				unitdata.G=g
				unitdata.B=b
				--get type data
				local faction,class,atype=NPA_Type_GetInfoByFrameColor(r,g,b,framedata)
				unitdata.Faction=faction
				unitdata.Class=class
				unitdata.Type=atype
				--fire type change event
				NPA_EventHandler_FireEvent(8,"Type_Updated",framedata)
			end
		end)
	end,
	--------
	function()
		-------unregister all events
		NPA.EventHandler.RegisterEvent(2,"DataCollector_CollectUnit","DataCollector_Type",nil)
		NPA.EventHandler.RegisterEvent(1,"NamePlate_DefaultMain_OnUpdate","DataCollector_Type",nil)
	end,
	--data transfer function,transfer frame-based unitdata to guid-based unitdata
	function(unitdata,frameunitdata)
		--use frame-based first as faction may change (like Mind-Controll) <==scrath that
		--this may cause some problem and i don't know why
		unitdata.Faction=unitdata.Faction or frameunitdata.Faction
		--use guid-based before frame-based ,as type and class won't change
		unitdata.Type=unitdata.Type or frameunitdata.Type
		unitdata.Class=unitdata.Class or frameunitdata.Class
	end
	)
